routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['install']], function () {
	
	Route::get('/', function(){
		return redirect('login');
	});
	
    Auth::routes(['register' => false]);
	Route::get('/logout', 'Auth\LoginController@logout');
	
	Route::group(['middleware' => ['auth','verified']], function () {
		
		Route::get('dashboard', 'DashboardController@index');
		
		//Profile Controller
		Route::get('profile/edit', 'ProfileController@edit');
		Route::post('profile/update', 'ProfileController@update');
		Route::get('profile/change_password', 'ProfileController@change_password');
		Route::post('profile/update_password', 'ProfileController@update_password');
		

		/** Admin Only Route **/
		Route::group(['middleware' => ['admin']], function () {
			
			//User Management
			Route::resource('users','UserController');

			//User Roles
			Route::resource('roles','RoleController');
			
			//Permission Controller
		    Route::get('permission/control/{user_id?}', 'PermissionController@index')->name('permission.index');
			Route::post('permission/store', 'PermissionController@store')->name('permission.store');

			//Language Controller
			Route::resource('languages','LanguageController');	
			
			//Utility Controller
			Route::match(['get', 'post'],'administration/general_settings/{store?}', 'UtilityController@settings')->name('settings.update_settings');
			Route::post('administration/upload_logo', 'UtilityController@upload_logo')->name('settings.uplaod_logo');
			Route::get('administration/database_backup_list', 'UtilityController@database_backup_list')->name('database_backups.list');
			Route::get('administration/create_database_backup', 'UtilityController@create_database_backup')->name('database_backups.create');
			Route::delete('administration/destroy_database_backup/{id}', 'UtilityController@destroy_database_backup');
			Route::get('administration/download_database_backup/{id}', 'UtilityController@download_database_backup')->name('database_backups.download');
			Route::post('administration/remove_cache', 'UtilityController@remove_cache')->name('settings.remove_cache');

			//Email Template
			/*Route::resource('email_templates','EmailTemplateController')->only([
				'index', 'create', 'store', 'show', 'edit', 'update', 'destroy'
			]);*/	
			
		});

        /** Dynamic Permission **/
		Route::group(['middleware' => ['permission']], function () {
			
			//Customer Controller
			Route::resource('customers','CustomerController');

			//Vendor Controller
			Route::resource('vendors','VendorController');

			//Account Controller
			Route::resource('accounts','AccountController');

			//Income Controller
			Route::get('income/get_table_data','IncomeController@get_table_data');
			Route::resource('income','IncomeController');

			//Expense Controller
			Route::get('expense/get_table_data','ExpenseController@get_table_data');
			Route::resource('expense','ExpenseController');

			//Currency Controller
			Route::resource('currency','CurrencyController');

			//Income & Expense Category
			Route::resource('transaction_categories','CategoryController');

			//Transfer Controller
			Route::resource('transfers','TransferController');

			//Payment Methods
			Route::resource('payment_methods','PaymentMethodController');

			//Reports Controller
			Route::match(['get','post'],'reports/income_summary','ReportController@income_summary')->name('reports.income_summary');
			Route::match(['get','post'],'reports/expense_summary','ReportController@expense_summary')->name('reports.expense_summary');

			Route::match(['get','post'],'reports/income_expense_summary','ReportController@income_expense_summary')->name('reports.income_expense_summary');

		});
	
	});

});

//Socila Login
Route::get('/login/{provider}', 'Auth\SocialController@redirect');
Route::get('/login/{provider}/callback','Auth\SocialController@callback');

//JSON data for dashboard chart
Route::get('dashboard/json_month_wise_income_expense','DashboardController@json_month_wise_income_expense')->middleware('auth');
Route::get('dashboard/json_income_by_category','DashboardController@json_income_by_category')->middleware('auth');
Route::get('dashboard/json_expense_by_category','DashboardController@json_expense_by_category')->middleware('auth');

//Ajax Select2 Controller
Route::get('ajax/get_table_data','Select2Controller@get_table_data');

Route::get('/installation', 'Install\InstallController@index');
Route::get('install/database', 'Install\InstallController@database');
Route::post('install/process_install', 'Install\InstallController@process_install');
Route::get('install/create_user', 'Install\InstallController@create_user');
Route::post('install/store_user', 'Install\InstallController@store_user');
Route::get('install/system_settings', 'Install\InstallController@system_settings');
Route::post('install/finish', 'Install\InstallController@final_touch');

//Update System
Route::get('migration/update', 'Install\UpdateController@update_migration');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
	protected $fillable = [
        'name', 'email', 'password', 'user_type', 'status', 'profile_picture',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
	
	public function getCreatedAtAttribute($value)
    {
		$date_format = get_date_format();
		$time_format = get_time_format();
        return \Carbon\Carbon::parse($value)->format("$date_format $time_format");
    }
	
	public function role(){
		return $this->belongsTo('App\Role','role_id')->withDefault();
	}
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use App\User;
use Validator;
use Hash;

class UserController extends Controller
{
	
	/**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        date_default_timezone_set(get_option('timezone','Asia/Dhaka'));
    }
	
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::all()->sortByDesc('id');
        return view('backend.user.list',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        if( ! $request->ajax()){
           return view('backend.user.create');
        }else{
           return view('backend.user.modal.create');
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {	
        $validator = Validator::make($request->all(), [
            'name' => 'required|max:255',
			'email' => 'required|email|unique:users|max:255',
            'user_type' => 'required',
			'role_id' => 'required_if:user_type,user',
			'status' => 'required',
			'profile_picture' => 'nullable|image',
			'password' => 'required|min:6',
        ],[
            'role_id.required_if' => 'User Role is required'
        ]);

        if ($validator->fails()) {
            if($request->ajax()){ 
                return response()->json(['result'=>'error','message'=>$validator->errors()->all()]);
            }else{
                return redirect()->route('users.create')
                	             ->withErrors($validator)
                	             ->withInput();
            }			
        }
	
	    $profile_picture = "";
        if($request->hasfile('profile_picture'))
	    {
		    $file = $request->file('profile_picture');
		    $profile_picture = time().$file->getClientOriginalName();
		    $file->move(public_path()."/uploads/profile/", $profile_picture);
	    }

        $user = new User();
        $user->name = $request->input('name');
		$user->email = $request->input('email');
		$user->user_type = $request->input('user_type');
		$user->role_id = $request->input('role_id');
		$user->status = $request->input('status');
		$user->profile_picture = $profile_picture;
		$user->email_verified_at = date('Y-m-d H:i:s');
		$user->password = Hash::make($request->password);

        $user->save();
		
		//Prefix Output
		$user->status = user_status($user->status);
		$user->user_type = ucwords($user->user_type);
		$user->profile_picture = '<img src="' . profile_picture($user->profile_picture) . '" class="thumb-sm rounded-circle mr-2">';

        if(! $request->ajax()){
           return redirect()->route('users.create')->with('success', _lang('Saved Successfully'));
        }else{
           return response()->json(['result'=>'success','action'=>'store','message'=>_lang('Saved Successfully'),'data'=>$user, 'table' => '#users_table']);
        }
        
   }
	

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id)
    {
        $user = User::find($id);
        if(! $request->ajax()){
            return view('backend.user.view',compact('user','id'));
        }else{
            return view('backend.user.modal.view',compact('user','id'));
        } 
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Request $request,$id)
    {
        $user = User::find($id);
        if(! $request->ajax()){
            return view('backend.user.edit',compact('user','id'));
        }else{
            return view('backend.user.modal.edit',compact('user','id'));
        }  
        
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
		$validator = Validator::make($request->all(), [
			'name' => 'required|max:255',
			'email' => [
                'required',
				'email',
                Rule::unique('users')->ignore($id),
            ],
			'user_type' => 'required',
            'role_id' => 'required_if:user_type,user',
			'status' => 'required',
			'profile_picture' => 'nullable|image',
			'password' => 'nullable|min:6',
		],[
            'role_id.required_if' => 'User Role is required'
        ]);

		if ($validator->fails()) {
			if($request->ajax()){ 
				return response()->json(['result'=>'error','message'=>$validator->errors()->all()]);
			}else{
				return redirect()->route('users.edit', $id)
							->withErrors($validator)
							->withInput();
			}			
		}
	
        if($request->hasfile('profile_picture'))
	    {
		    $file = $request->file('profile_picture');
		    $profile_picture = time().$file->getClientOriginalName();
		    $file->move(public_path()."/uploads/profile/", $profile_picture);
	    }	
		
        $user = User::find($id);
		$user->name = $request->input('name');
		$user->email = $request->input('email');
		$user->user_type = $request->input('user_type');
		$user->role_id = $request->input('role_id');
		$user->status = $request->input('status');
		if($request->hasfile('profile_picture')){
			$user->profile_picture = $profile_picture;
		}
		if($request->password){
            $user->password = Hash::make($request->password);
        }
	
        $user->save();
		
		//Prefix Output
		$user->status = user_status($user->status);
		$user->user_type = ucwords($user->user_type);
		$user->profile_picture = '<img src="' . profile_picture($user->profile_picture) . '" class="thumb-sm rounded-circle mr-2">';

		
		if(! $request->ajax()){
           return redirect()->route('users.index')->with('success', _lang('Updated Successfully'));
        }else{
		   return response()->json(['result'=>'success','action'=>'update', 'message'=>_lang('Updated Successfully'),'data'=>$user, 'table' => '#users_table']);
		}
	    
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $user = User::find($id);
        $user->delete();
        return redirect()->route('users.index')->with('success',_lang('Deleted Successfully'));
    }
}

resources/views/backend/user/modal/create.blade.php
<form method="post" class="ajax-screen-submit" autocomplete="off" action="{{ route('users.store') }}" enctype="multipart/form-data">
	{{ csrf_field() }}
	
	<div class="row p-2">
		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Name') }}</label>						
				<input type="text" class="form-control" name="name" value="{{ old('name') }}" required>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Email') }}</label>						
				<input type="text" class="form-control" name="email" value="{{ old('email') }}" required>
			</div>
		</div>
		
		
		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Password') }}</label>						
				<input type="password" class="form-control" name="password" value="{{ old('password') }}" required>
			</div>
		</div>

		<div class="col-md-6">
			<div class="form-group">
				<label class="control-label">{{ _lang('User Type') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ old('user_type') }}" name="user_type"  required>
					<option value="">{{ _lang('Select One') }}</option>
					<option value="admin">{{ _lang('Admin') }}</option>
					<option value="user">{{ _lang('User') }}</option>
				</select>
			</div>
		</div>
		
		<div class="col-md-6">
			<div class="form-group">
				<label class="control-label">{{ _lang('User Role') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ old('role_id') }}" name="role_id">
					<option value="">{{ _lang('Select One') }}</option>
					{{ create_option('roles','id','name') }}
				</select>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Status') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ old('status') }}" name="status" required>
					<option value="">{{ _lang('Select One') }}</option>
					<option value="1">{{ _lang('Active') }}</option>
					<option value="0">{{ _lang('In Active') }}</option>
				</select>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Profile Picture') }}</label>						
				<input type="file" class="form-control dropify" name="profile_picture" >
			</div>
		</div>

		
		<div class="col-md-12">
			<div class="form-group">
				<button type="reset" class="btn btn-danger">{{ _lang('Reset') }}</button>
				<button type="submit" class="btn btn-primary">{{ _lang('Save') }}</button>
			</div>
		</div>
	</div>
</form>

resources/views/backend/user/modal/edit.blade.php
<form method="post" class="ajax-screen-submit" autocomplete="off" action="{{ action('UserController@update', $id) }}" enctype="multipart/form-data">
	{{ csrf_field()}}
	<input name="_method" type="hidden" value="PATCH">				
	
	<div class="row p-2">
		<div class="col-md-12">
			<div class="form-group">
			   <label class="control-label">{{ _lang('Name') }}</label>						
			   <input type="text" class="form-control" name="name" value="{{ $user->name }}" required>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
			   <label class="control-label">{{ _lang('Email') }}</label>						
			   <input type="text" class="form-control" name="email" value="{{ $user->email }}" required>
			</div>
		</div>
		
		<div class="col-md-12">
			<div class="form-group">
			   <label class="control-label">{{ _lang('Password') }}</label>						
			   <input type="password" class="form-control" name="password" value="">
			</div>
		</div>

		<div class="col-md-6">
			<div class="form-group">
				<label class="control-label">{{ _lang('User Type') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ $user->user_type }}" name="user_type"  required>
					<option value="">{{ _lang('Select One') }}</option>
					<option value="admin">{{ _lang('Admin') }}</option>
					<option value="user">{{ _lang('User') }}</option>
				</select>
			</div>
		</div>
		
		<div class="col-md-6">
			<div class="form-group">
				<label class="control-label">{{ _lang('User Role') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ $user->role_id }}" name="role_id">
					<option value="">{{ _lang('Select One') }}</option>
					{{ create_option('roles','id','name') }}
				</select>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
				<label class="control-label">{{ _lang('Status') }}</label>						
				<select class="form-control select2 auto-select" data-selected="{{ $user->status }}" name="status" required>
					<option value="">{{ _lang('Select One') }}</option>
					<option value="1">{{ _lang('Active') }}</option>
					<option value="0">{{ _lang('In Active') }}</option>
				</select>
			</div>
		</div>

		<div class="col-md-12">
			<div class="form-group">
			   <label class="control-label">{{ _lang('Profile Picture') }}</label>						
			   <input type="file" class="form-control dropify" name="profile_picture">
			</div>
		</div>

		<div class="form-group">
			<div class="col-md-12">
				<button type="submit" class="btn btn-primary">{{ _lang('Update') }}</button>
			</div>
		</div>
	</div>
</form>

resources/views/backend/user/modal/view.blade.php
<table class="table table-bordered">
	<tr><td>{{ _lang('Name') }}</td><td>{{ $user->name }}</td></tr>
	<tr><td>{{ _lang('Email') }}</td><td>{{ $user->email }}</td></tr>
	<tr><td>{{ _lang('User Type') }}</td><td>{{ $user->user_type }}</td></tr>
	<tr><td>{{ _lang('User Role') }}</td><td>{{ $user->role->name }}</td></tr>
	<tr><td>{{ _lang('Status') }}</td><td>{!! xss_clean(user_status($user->status)) !!}</td></tr>
	<tr><td>{{ _lang('Profile Picture') }}</td><td>{{ $user->profile_picture }}</td></tr>
	<tr><td>{{ _lang('Created At') }}</td><td>{{ $user->created_at }}</td></tr>
</table>